<!-- 
   - README.md
   - =========
   - 
   - [[http://www.ljll.fr/lehyaric][Antoine Le Hyaric]]
   - 
   - Sorbonne Universit, CNRS, Laboratoire Jacques-Louis Lions, F-75005, Paris, France
   - 
   - ----------------------------
   - This file is part of FreeFEM
   - ----------------------------
   - FreeFEM is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as
   - published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.
   - FreeFEM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
   - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
   - You should have received a copy of the GNU Lesser General Public License along with FreeFEM; if not, write to the Free Software
   - Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
   - 
   - _TODO_ [[file:::56]]
   - [[elisp:(progn (org-link-minor-mode) (setq org-link-descriptive nil) (org-toggle-link-display))][hide links]] [[elisp:(progn (org-link-minor-mode) (setq org-link-descriptive t) (org-toggle-link-display))][show links]] [[elisp:(alh-1dex-open)][open 1dex]] [[elisp:(alh-1dex-update)][update 1dex]]
   - 
   - [[elisp:(alh-set-keywords)][set keywords]] ([[file:~/alh/bin/headeralh][headeralh]])
   - emacs-keywords freefem markdown start=11/06/24 univ update=25/06/24
   -->

<!-- [[https://docs.github.com/fr/get-started/writing-on-github/getting-started-with-writing-and-formatting-on-github/basic-writing-and-formatting-syntax]] -->

## [FreeFEM](https://www.freefem.org) in Javascript ([website](https://www.ljll.fr/lehyaric/ffjs/))

***Version 24.1***

[FreeFEM](http://www.freefem.org) is a partial differential equation solver. Its primary users are mathematicians. As for many other
software, some computing knowledge is required to install it on the many different computer systems that mathematicians use. But
mathematical researchers, teachers or students should not be required to have this level of computing knowledge.  This Javascript version
works straight out of an [HTML](http://fr.wikipedia.org/wiki/Hypertext_Markup_Language) page, on any recent internet browser, both online or
offline, on any operating system where such a browser is available. Creating a FreeFEM program means editing a standard HTML page, which can
become a complete [Literate program](http://en.wikipedia.org/wiki/Literate_programming) with math equations, editable portions and
graphics. FreeFEM-js users can exchange their programs as HTML files with modifiable and fixed parts.

This project ([web page](https://www.ljll.fr/lehyaric/ffjs/), [github](https://github.com/alh104/ffjs)) can also be compiled into a
universal standalone Javascript executable, which can run anywhere with [Node.js](https://nodejs.org).

Questions, comments and patches are welcome on the [FreeFEM forum](https://community.freefem.org).

### Build commands

Plase download [ffkernel](https://www.ljll.fr/lehyaric/ffcs/ffkernel.htm) and [fflib](https://www.ljll.fr/lehyaric/ffcs/fflib.htm) first,
and unpack them in the same directory as ffjs. Several binary versions can be compiled : **dev** (development version; the default), **min**
(optimized for speed and minimum size) and **native**. To create binaries for any architecture (result in `bin_[arch]`) :

```
make -j BINTAG=[arch] BINGOAL=all
```

### FAQ

**What is the required computer configuration?**

FreeFEM-js works on any computer or smartphone. It runs in the internet browser. No download or install is required.

**Where are the numerical computations done?**

There is no computational server. FreeFEM-js runs on the machine where a browser is opened. Scripts saved locally as HTML pages with their
Javascript dependencies will still work as they do not depend on any online facility.
      
**Is there a risk of virus infection?**

FreeFEM-js runs inside the Javascript virtual machine, which is built to stop viruses.
      
**How to run FreeFEM-js scripts when disconnected from the internet?**

Saving an HTML page containing FreeFEM-js to a local disk is enough to make it available offline. Saving a page can be also useful to keep a
record of a modified script or to save on slow or data-capped internet connections.

**Will any FreeFEM script run?**

At the moment, scripts will work only if they do not contain the following features (not compiled into Javascript
yet) : 3d graphs, include files, dynamic libraries.

### With many thanks to the projects which where used in the making of FreeFEM-js

+ [Debian Linux](https://www.debian.org)
+ [Emscripten](http://kripken.github.io/emscripten-site/)
+ [JQuery](https://jquery.com/)
+ [Bootstrap](http://getbootstrap.com)
+ [MathJax](https://www.mathjax.org/)

<!-- 
   - Local Variables:
   - mode:markdown
   - indent-tabs-mode:nil
   - eval:(visual-line-mode t)
   - coding:utf-8
   - eval:(flyspell-mode)
   - eval:(outline-minor-mode)
   - eval:(org-link-minor-mode)
   - End:
   -->
<!-- LocalWords: emacs
   -->
