// ~/ffalh/ffjs/react/FreeFemJS/App.js
// ===================================
// 
// 
//       \|||/                                     
//       (o o)            _                  _     
// ,-ooO--(_)------,     / \   _ __  _ __   (_)___ 
// |    _________  |    / _ \ | '_ \| '_ \  | / __|
// |   /  _._   /  |   / ___ \| |_) | |_) | | \__ \
// |  /________/   |  /_/   \_\ .__/| .__(_)/ |___/
// '-----------ooO-'          |_|   |_|   |__/     
// 
// Originally from React Native Template
// Written by Antoine Le Hyaric ([[http://www.ljll.math.upmc.fr/lehyaric]])
// 
// _HERE_ [[file:::110]] [[file:::29]] [[file:::31]]
// [[elisp:(org-toggle-link-display)][show links]]
// 
// [[elisp:(alh-set-keywords)][set keywords]] ([[file:~/alh/bin/headeralh][headeralh]])
// emacs-keywords jsx origin="React Native Template" start=05/01/22 written

// Documentation:
// React Native components tutorial https://reactnative.dev/docs/getting-started
// React Native Navigation tutorial https://reactnavigation.org/docs/getting-started/
// React Native Components and API https://reactnative.dev/docs/components-and-apis
// JSX details https://reactjs.org/docs/jsx-in-depth.html

// ALHTODO 08/01/22 Navigation trois top tabs pour editeur/graphiques/textual output, navigation bottom tabs pour les graphiques

// ALHTODO 07/01/22 où mettre les interactions avec le graphique?

import * as React from 'react';
import {Button,View,ScrollView,Text} from 'react-native';
import { NavigationContainer } from '@react-navigation/native';
import { createNativeStackNavigator } from '@react-navigation/native-stack';
import { createBottomTabNavigator } from '@react-navigation/bottom-tabs';
import QuillEditor from 'react-native-quill-editor' // [[https://www.npmjs.com/package/react-native-quill-editor?activeTab=readme]]
import * as THREE from 'three';

function SettingsScreen({ navigation }) {
  return (
    <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
      <Text>Settings Screen</Text>
      <Button
        title="Go to Profile"
        onPress={() => navigation.navigate('Profile')}
      />
    </View>
  );
}

function ProfileScreen({ navigation }) {
  return (
    <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
      <Text>Profile Screen</Text>
      <Button
        title="Go to Settings"
        onPress={() => navigation.navigate('Settings')}
      />
    </View>
  );
}

function HomeScreen({ navigation }) {
  return (
    <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
      <Text>Home Screen</Text>
      <Button
        title="Go to Details"
        onPress={() => navigation.navigate('Details')}
      />
    </View>
  );
}

function DetailsScreen({ navigation }) {
  return (
    <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
      <Text>Details Screen</Text>
      <Button
        title="Go to Details... again"
        onPress={() => navigation.push('Details')}
      />
    </View>
  );
}
const Tab = createBottomTabNavigator();
const SettingsStack = createNativeStackNavigator();
const HomeStack = createNativeStackNavigator();

export default function App(){

  // Fonction permettant de créer un affichage dans notre GLVIEW
  // [[https://www.oktopod.io/comment-utiliser-expo-et-three-js-avec-react-native-1-2/]]
  async function _onContextCreate (gl) {
        
    const { drawingBufferWidth: width, drawingBufferHeight: height } = gl; // Définition des dimensions d'affichage
    const sceneColor = 0x10505b; // Couleur de fond de la zone

    // Création d'un "Renderer" WEBGL sans le DOM habituel avec THRE
    let renderer = new ExpoTHREE.Renderer({ gl });
    renderer.setSize(width, height);
    renderer.setClearColor(sceneColor);

    // Création de la caméra 3D avec positionnement dans l'espace
    let camera = new THREE.PerspectiveCamera(80, width / height, 0.01, 1000);
    camera.position.set(2, 5, 5);

    // Création de la scène à afficher, et ajout d'une grille pour aider au positionnement
    let scene = new THREE.Scene();
    scene.add(new THREE.GridHelper(10, 10));

    // Rendu de la scène 
    renderer.render(scene, camera);
    gl.endFrameEXP();
  }
  
  return(
    <NavigationContainer>
      <Tab.Navigator
	screenOptions={{
	  headerStyle:{
	    backgroundColor:'#ffa900',
	  }
	}}
      >
	
        <Tab.Screen name="Editor">
          {() => (

	    // [[https://www.npmjs.com/package/react-native-quill-editor?activeTab=readme]]
	    <QuillEditor
	      options={{
		placeholder: '请赋诗一首...',
	      }}
	      // ALHTODO 12/01/22 09:21:55 onChange={onChange}
	    />	    
          )}
        </Tab.Screen>
	
        <Tab.Screen name="Graphs">
          {() => (
            <Tab.Navigator
	      screenOptions={{ headerShown:false }}
	    >
              <Tab.Screen name="fig 1">
		<GLView
		  style={{ flex: 1 }}
		  onContextCreate={_onContextCreate}
		/>
	      </Tab.Screen>
              ///<Tab.Screen name="Home" component={HomeScreen} />
              ///<Tab.Screen name="Details" component={DetailsScreen} />
            </Tab.Navigator>
          )}
        </Tab.Screen>
	
        <Tab.Screen name="Output">
          {() => (
	    <ScrollView>
	      <Text>FreeFEM output</Text>
	    </ScrollView>
          )}
        </Tab.Screen>
      </Tab.Navigator>
    </NavigationContainer>
  );
}

// Local Variables:
// mode:js-jsx
// eval:(org-link-minor-mode)
// eval:(visual-line-mode t)
// coding:utf-8
// eval:(flyspell-prog-mode)
// eval:(outline-minor-mode)
// End:
// LocalWords: emacs
